/*
 *  CachedFunction.h
 *  ProgrammazioneAOggetti
 *
 *  Created by Michele Mastrogiovanni Second on 05/12/08.
 *  Copyright 2008 __MyCompanyName__. All rights reserved.
 *
 */

#include <map> 
#include "Function.h"

using namespace std;


#ifndef _CACHED_FUNCTION_H_
#define _CACHED_FUNCTION_H_

#define MAX_SIZE	10

class CachedFunction : public Function {
public:
	CachedFunction( Function * f ) : f_( f ), size_( 0 ) {
	}
	
	virtual float compute( float x );

	virtual void dump();
	
protected:
	Function * f_;

#ifdef MAX_SIZE	
	int size_;
	float X[ MAX_SIZE ];
	float Y[ MAX_SIZE ];
#else
	map< float, float > cache_;
#endif
	
};

#endif
