
#include "Composition.h"

Composition::Composition( Function * f, Function * g ) : f_( f ), g_( g ) 
{
}

float 
Composition::compute( float x ) 
{
	return f_ -> compute( g_ -> compute( x ) );
}
	
void 
Composition::dump() 
{
	printf( "F( G( x ) ) where F( x ) = " );
	f_ -> dump();
	printf( " and G( x ) = " );
	g_ -> dump();
}
