
#include "Polinomy.h"
#include "math.h"

Polinomy::Polinomy( int length ) 
{
	length_ = length;
	coefficients_ = new float[ length_ ];
	for ( int i = 0; i < length_; i ++ )
		coefficients_[ i ] = 0;
}

Polinomy::~Polinomy() {
	delete( coefficients_ );
}

void 
Polinomy::setCoefficient( int index, float v ) {
	coefficients_[ index ] = v;
}

float 
Polinomy::compute( float x ) 
{
	float sum_ = 0;
	for ( int i = 0; i < length_; i++ )
		sum_ += coefficients_[ i ] * pow( x, i );
	return sum_;
}

void 
Polinomy::dump( float x ) {
	Function::dump( x );
}

void 
Polinomy::dump() 
{
	for ( int i = 0; i < length_; i++ ) {
		int index = length_ - i - 1;
		float c = coefficients_[ index ];
		if ( c == 0.0 )
			continue;
		if ( c > 0 ) {
			if ( i > 0 ) {
				printf( "+ " );
			}
		}
		else {
			printf( "- " );
			c = -c;
		}
		printf( "%.3f ", c );
		if ( index == 1 )
			printf( "X " );
		if ( index > 1 )
			printf( "X^%d ", index );
	}
}

