
#include "math.h"
#include <stdio.h>
#include <iostream>

#include "Parabola.h"
#include "Retta.h"
#include "DefiniteIntegral.h"

#include "Timer.h"
#include "CachedFunction.h"

using namespace std;

int main() {

	Parabola p( 1, -2, 3 );
	CachedFunction cf( & p );
	DefiniteIntegral di( 0, 1, 10 );
	
	Timer timer( & di );
	
	cout << "Normal" << endl;

	di.dump();
	printf( " of F( X ) = " );
	p.dump();
	printf( " = %.3f\n", di.evaluate( & p ) );
	cout << timer.evaluate( & p ) << endl;
	
	cout << "Cache" << endl;
	di.dump();
	printf( " of F( X ) = " );
	cf.dump();
	printf( " = %.3f\n", di.evaluate( & cf ) );
	cout << timer.evaluate( & cf ) << endl;
	
	return 0;
	
}
